package gov.nist.biometrics.bias {
	
	[Bindable]
	public class Utilities {
		private static var instance:gov.nist.biometrics.bias.Utilities;// = new Environment();
		
		public static function getInstance():Utilities {
			if (instance == null)
				instance = new Utilities();
			
			return instance;
		}
		
		public var ServiceHostname:String = "http://localhost"; //"http://wsbd-face-wired.mback.local";
		public var ServicePort:int = 12345;
		public var ServiceContext:String = "";
		
		public var WorkspaceWidth:int = 1024;
		public var WorkspaceHeight:int = 768;
		public var WorkspaceX:int = 10;
		public var WorkspaceY:int = 10;
		public var Margin:int = 10;
		
		public var SuccessfulOperationColor:String = "#00ff00";
		public var FailedOperationColor:String = "#ff0000";
		public var FaultedOperationColor:String = "#0000ff";
		
		public function VisibleWorkspaceWidth():int {
			return WorkspaceWidth - (2 * Margin);
		}
		
		public function VisibleWorkspaceHeight():int {
			var v:ServiceManager = new ServiceManager();
			return WorkspaceHeight - (2 * Margin);
		}
		
		public function CreateGuid():String {
			var result:String = "";
			
			for (var i:int = 0; i < 32; i++) {
				if ((i == 8) || (i == 12) || (i == 16) || (i == 20)) {
					result += "-";
				}
				
				var nextDigit:int = Math.random() * 16;
				if (nextDigit >= 10) {
					switch (nextDigit) {
						case 10:
							result += "A";
							break;
						case 11:
							result += "B";
							break
						case 12:
							result += "C";
							break
						case 13:
							result += "D";
							break;
						case 14:
							result += "E";
							break;
						case 15:
							result += "F";
							break;
					}
				} else {
					result += nextDigit;
				}
			}
			
			return result;
		}
	}
}