/**
 * This is a generated class and is not intended for modfication.  To customize behavior
 * of this value object you may modify the generated sub-class of this class - QualityData.as.
 */

package valueObjects
{
import com.adobe.fiber.services.IFiberManagingService;
import com.adobe.fiber.valueobjects.IValueObject;
import flash.events.Event;
import flash.events.EventDispatcher;
import mx.events.PropertyChangeEvent;

import flash.net.registerClassAlias;
import flash.net.getClassByAlias;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;

use namespace model_internal;

[ExcludeClass]
public class _Super_QualityData extends flash.events.EventDispatcher implements com.adobe.fiber.valueobjects.IValueObject
{
    model_internal static function initRemoteClassAliasSingle(cz:Class) : void 
    {
    }   
     
    model_internal static function initRemoteClassAliasAllRelated() : void 
    {
    }

	model_internal var _dminternal_model : _QualityDataEntityMetadata;

	/**
	 * properties
	 */
	private var _internal_QualityScore : Number;
	private var _internal_AlgorithmVendor : String;
	private var _internal_AlgorithmVendorProductID : String;
	private var _internal_AlgorithmVersion : String;

    private static var emptyArray:Array = new Array();

    /**
     * derived property cache initialization
     */  
    model_internal var _cacheInitialized_isValid:Boolean = false;   
    
	model_internal var _changeWatcherArray:Array = new Array();   

	public function _Super_QualityData() 
	{	
		_model = new _QualityDataEntityMetadata(this);
	
		// Bind to own data properties for cache invalidation triggering  
       
	}

    /**
     * data property getters
     */
	[Bindable(event="propertyChange")] 
    public function get QualityScore() : Number    
    {
            return _internal_QualityScore;
    }    
	[Bindable(event="propertyChange")] 
    public function get AlgorithmVendor() : String    
    {
            return _internal_AlgorithmVendor;
    }    
	[Bindable(event="propertyChange")] 
    public function get AlgorithmVendorProductID() : String    
    {
            return _internal_AlgorithmVendorProductID;
    }    
	[Bindable(event="propertyChange")] 
    public function get AlgorithmVersion() : String    
    {
            return _internal_AlgorithmVersion;
    }    

    /**
     * data property setters
     */      
    public function set QualityScore(value:Number) : void 
    {    	
        var recalcValid:Boolean = false;
    	
    	
    	var oldValue:Number = _internal_QualityScore;               
        if (oldValue !== value)
        {
            _internal_QualityScore = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "QualityScore", oldValue, _internal_QualityScore));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set AlgorithmVendor(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_AlgorithmVendor == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_AlgorithmVendor;               
        if (oldValue !== value)
        {
            _internal_AlgorithmVendor = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "AlgorithmVendor", oldValue, _internal_AlgorithmVendor));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set AlgorithmVendorProductID(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_AlgorithmVendorProductID == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_AlgorithmVendorProductID;               
        if (oldValue !== value)
        {
            _internal_AlgorithmVendorProductID = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "AlgorithmVendorProductID", oldValue, _internal_AlgorithmVendorProductID));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set AlgorithmVersion(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_AlgorithmVersion == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_AlgorithmVersion;               
        if (oldValue !== value)
        {
            _internal_AlgorithmVersion = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "AlgorithmVersion", oldValue, _internal_AlgorithmVersion));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    

    /**
     * data property setter listeners
     */   

   model_internal function setterListenerAnyConstraint(value:flash.events.Event):void
   {
        if (model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }        
   }   

    /**
     * valid related derived properties
     */
    model_internal var _isValid : Boolean;
    model_internal var _invalidConstraints:Array = new Array();
    model_internal var _validationFailureMessages:Array = new Array();

    /**
     * derived property calculators
     */

    /**
     * isValid calculator
     */
    model_internal function calculateIsValid():Boolean
    {
        var violatedConsts:Array = new Array();    
        var validationFailureMessages:Array = new Array();    

		if (_model.isAlgorithmVendorAvailable && _internal_AlgorithmVendor == null)
		{
			violatedConsts.push("AlgorithmVendorIsRequired");
			validationFailureMessages.push("AlgorithmVendor is required");
		}
		if (_model.isAlgorithmVendorProductIDAvailable && _internal_AlgorithmVendorProductID == null)
		{
			violatedConsts.push("AlgorithmVendorProductIDIsRequired");
			validationFailureMessages.push("AlgorithmVendorProductID is required");
		}
		if (_model.isAlgorithmVersionAvailable && _internal_AlgorithmVersion == null)
		{
			violatedConsts.push("AlgorithmVersionIsRequired");
			validationFailureMessages.push("AlgorithmVersion is required");
		}

		var styleValidity:Boolean = true;
	
	
	
	
    
        model_internal::_cacheInitialized_isValid = true;
        model_internal::invalidConstraints_der = violatedConsts;
        model_internal::validationFailureMessages_der = validationFailureMessages;
        return violatedConsts.length == 0 && styleValidity;
    }  

    /**
     * derived property setters
     */

    model_internal function set isValid_der(value:Boolean) : void
    {
       	var oldValue:Boolean = model_internal::_isValid;               
        if (oldValue !== value)
        {
        	model_internal::_isValid = value;
        	_model.model_internal::fireChangeEvent("isValid", oldValue, model_internal::_isValid);
        }        
    }

    /**
     * derived property getters
     */

    [Transient] 
	[Bindable(event="propertyChange")] 
    public function get _model() : _QualityDataEntityMetadata
    {
		return model_internal::_dminternal_model;              
    }	
    
    public function set _model(value : _QualityDataEntityMetadata) : void       
    {
    	var oldValue : _QualityDataEntityMetadata = model_internal::_dminternal_model;               
        if (oldValue !== value)
        {
        	model_internal::_dminternal_model = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_model", oldValue, model_internal::_dminternal_model));
        }     
    }      

    /**
     * methods
     */  


    /**
     *  services
     */                  
     private var _managingService:com.adobe.fiber.services.IFiberManagingService;
    
     public function set managingService(managingService:com.adobe.fiber.services.IFiberManagingService):void
     {
         _managingService = managingService;
     }                      
     
    model_internal function set invalidConstraints_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_invalidConstraints;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_invalidConstraints = value;   
			_model.model_internal::fireChangeEvent("invalidConstraints", oldValue, model_internal::_invalidConstraints);   
        }     	             
    }             
    
     model_internal function set validationFailureMessages_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_validationFailureMessages;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_validationFailureMessages = value;   
			_model.model_internal::fireChangeEvent("validationFailureMessages", oldValue, model_internal::_validationFailureMessages);   
        }     	             
    }        
     
     // Individual isAvailable functions     
	// fields, getters, and setters for primitive representations of complex id properties

}

}
