﻿Option Strict On

Module Constants

    Private m_GalleryBaseDirectory As String = "C:\Temp\BIAS"
    Public Property GalleryBaseDirectory As String
        Get
            Return m_GalleryBaseDirectory
        End Get
        Private Set(ByVal value As String)
            m_GalleryBaseDirectory = value
        End Set
    End Property

    Public Property MatchScoreThreshold As Integer = 12

    Public ReadOnly Property BindingMaxReceivedMessageSize As Integer
        Get
            Return Integer.MaxValue
        End Get
    End Property

    Public ReadOnly Property BindingMaxBufferSize As Integer
        Get
            Return Integer.MaxValue
        End Get
    End Property

    Private m_ServiceBaseAddress As String = "http://localhost:12345"
    Public Property ServiceBaseAddress As String
        Get
            Return m_ServiceBaseAddress
        End Get
        Private Set(ByVal value As String)
            m_ServiceBaseAddress = value
        End Set
    End Property

End Module