package gov.nist.biometrics.bias {
	import mx.controls.Button;

	public class Indicator extends Button {
		public static const EMPTY:String = "#DEEBFF";
		public static const PROGRESS:String = "#0000FF"; //"#FF6600";
		public static const COMPLETE:String = "#00FF00";
		public static const ERROR:String = "#FF0000";
		
		[Bindable]
		private var color:String = EMPTY;
		
		public function Indicator() {
		}
		
		public function update(color:String = EMPTY):void {
			this.color = color;
			
			if (getStyle("chromeColor") != color)
				setStyle("chromeColor", color);
		}
		
		public function clear():void {
			if (fileMonitor != null)
				fileMonitor.removeSample();
		}
		
		private var fileMonitor:FileMonitor;
		public function setFileMonitor(fileMonitor:FileMonitor):void { this.fileMonitor = fileMonitor; }		
		public function getFileMonitor():FileMonitor { return fileMonitor; }
	}
}