/**
 * This is a generated class and is not intended for modfication.  To customize behavior
 * of this value object you may modify the generated sub-class of this class - BIASIdentity.as.
 */

package valueObjects
{
import com.adobe.fiber.services.IFiberManagingService;
import com.adobe.fiber.valueobjects.IValueObject;
import flash.events.Event;
import flash.events.EventDispatcher;
import mx.collections.ArrayCollection;
import mx.events.PropertyChangeEvent;
import valueObjects.BIASBiometricDataType;
import valueObjects.BiographicDataType;

import flash.net.registerClassAlias;
import flash.net.getClassByAlias;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;

use namespace model_internal;

[ExcludeClass]
public class _Super_BIASIdentity extends flash.events.EventDispatcher implements com.adobe.fiber.valueobjects.IValueObject
{
    model_internal static function initRemoteClassAliasSingle(cz:Class) : void 
    {
    }   
     
    model_internal static function initRemoteClassAliasAllRelated() : void 
    {
        valueObjects.BiographicDataType.initRemoteClassAliasSingleChild();
        valueObjects.BiographicDataItemType.initRemoteClassAliasSingleChild();
        valueObjects.BiographicDataSetType.initRemoteClassAliasSingleChild();
        valueObjects.BIASBiometricDataType.initRemoteClassAliasSingleChild();
        valueObjects.CBEFF_BIR_Type.initRemoteClassAliasSingleChild();
        valueObjects.CBEFF_BIR_TypeBIR_InformationType.initRemoteClassAliasSingleChild();
        valueObjects.BIRInfoType.initRemoteClassAliasSingleChild();
        valueObjects.BDBInfoType.initRemoteClassAliasSingleChild();
        valueObjects.MultipleTypesType.initRemoteClassAliasSingleChild();
        valueObjects.SubtypeType.initRemoteClassAliasSingleChild();
        valueObjects.SBInfoType.initRemoteClassAliasSingleChild();
        valueObjects.BaseBIRType.initRemoteClassAliasSingleChild();
        valueObjects.BiometricDataElementType.initRemoteClassAliasSingleChild();
    }

	model_internal var _dminternal_model : _BIASIdentityEntityMetadata;

	/**
	 * properties
	 */
	private var _internal_SubjectID : String;
	private var _internal_IdentityClaim : String;
	private var _internal_EncounterID : String;
	private var _internal_EncounterList : ArrayCollection;
	private var _internal_BiographicData : valueObjects.BiographicDataType;
	private var _internal_BiographicDataElements : valueObjects.BiographicDataType;
	private var _internal_BiometricData : valueObjects.BIASBiometricDataType;

    private static var emptyArray:Array = new Array();

    /**
     * derived property cache initialization
     */  
    model_internal var _cacheInitialized_isValid:Boolean = false;   
    
	model_internal var _changeWatcherArray:Array = new Array();   

	public function _Super_BIASIdentity() 
	{	
		_model = new _BIASIdentityEntityMetadata(this);
	
		// Bind to own data properties for cache invalidation triggering  
       
	}

    /**
     * data property getters
     */
	[Bindable(event="propertyChange")] 
    public function get SubjectID() : String    
    {
            return _internal_SubjectID;
    }    
	[Bindable(event="propertyChange")] 
    public function get IdentityClaim() : String    
    {
            return _internal_IdentityClaim;
    }    
	[Bindable(event="propertyChange")] 
    public function get EncounterID() : String    
    {
            return _internal_EncounterID;
    }    
	[Bindable(event="propertyChange")] 
    public function get EncounterList() : ArrayCollection    
    {
            return _internal_EncounterList;
    }    
	[Bindable(event="propertyChange")] 
    public function get BiographicData() : valueObjects.BiographicDataType    
    {
            return _internal_BiographicData;
    }    
	[Bindable(event="propertyChange")] 
    public function get BiographicDataElements() : valueObjects.BiographicDataType    
    {
            return _internal_BiographicDataElements;
    }    
	[Bindable(event="propertyChange")] 
    public function get BiometricData() : valueObjects.BIASBiometricDataType    
    {
            return _internal_BiometricData;
    }    

    /**
     * data property setters
     */      
    public function set SubjectID(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_SubjectID == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_SubjectID;               
        if (oldValue !== value)
        {
            _internal_SubjectID = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "SubjectID", oldValue, _internal_SubjectID));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set IdentityClaim(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_IdentityClaim == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_IdentityClaim;               
        if (oldValue !== value)
        {
            _internal_IdentityClaim = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "IdentityClaim", oldValue, _internal_IdentityClaim));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set EncounterID(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_EncounterID == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_EncounterID;               
        if (oldValue !== value)
        {
            _internal_EncounterID = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "EncounterID", oldValue, _internal_EncounterID));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set EncounterList(value:*) : void
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_EncounterList == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:ArrayCollection = _internal_EncounterList;               
        if (oldValue !== value)
        {
            if (value is ArrayCollection)
            {
                _internal_EncounterList = value;
            }
            else if (value is Array)
            {
                _internal_EncounterList = new ArrayCollection(value);
            }
            else
            {
                throw new Error("value of EncounterList must be a collection");
            }
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "EncounterList", oldValue, _internal_EncounterList));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set BiographicData(value:valueObjects.BiographicDataType) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_BiographicData == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:valueObjects.BiographicDataType = _internal_BiographicData;               
        if (oldValue !== value)
        {
            _internal_BiographicData = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "BiographicData", oldValue, _internal_BiographicData));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set BiographicDataElements(value:valueObjects.BiographicDataType) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_BiographicDataElements == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:valueObjects.BiographicDataType = _internal_BiographicDataElements;               
        if (oldValue !== value)
        {
            _internal_BiographicDataElements = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "BiographicDataElements", oldValue, _internal_BiographicDataElements));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set BiometricData(value:valueObjects.BIASBiometricDataType) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_BiometricData == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:valueObjects.BIASBiometricDataType = _internal_BiometricData;               
        if (oldValue !== value)
        {
            _internal_BiometricData = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "BiometricData", oldValue, _internal_BiometricData));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    

    /**
     * data property setter listeners
     */   

   model_internal function setterListenerAnyConstraint(value:flash.events.Event):void
   {
        if (model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }        
   }   

    /**
     * valid related derived properties
     */
    model_internal var _isValid : Boolean;
    model_internal var _invalidConstraints:Array = new Array();
    model_internal var _validationFailureMessages:Array = new Array();

    /**
     * derived property calculators
     */

    /**
     * isValid calculator
     */
    model_internal function calculateIsValid():Boolean
    {
        var violatedConsts:Array = new Array();    
        var validationFailureMessages:Array = new Array();    

		if (_model.isSubjectIDAvailable && _internal_SubjectID == null)
		{
			violatedConsts.push("SubjectIDIsRequired");
			validationFailureMessages.push("SubjectID is required");
		}
		if (_model.isIdentityClaimAvailable && _internal_IdentityClaim == null)
		{
			violatedConsts.push("IdentityClaimIsRequired");
			validationFailureMessages.push("IdentityClaim is required");
		}
		if (_model.isEncounterIDAvailable && _internal_EncounterID == null)
		{
			violatedConsts.push("EncounterIDIsRequired");
			validationFailureMessages.push("EncounterID is required");
		}
		if (_model.isEncounterListAvailable && _internal_EncounterList == null)
		{
			violatedConsts.push("EncounterListIsRequired");
			validationFailureMessages.push("EncounterList is required");
		}
		if (_model.isBiographicDataAvailable && _internal_BiographicData == null)
		{
			violatedConsts.push("BiographicDataIsRequired");
			validationFailureMessages.push("BiographicData is required");
		}
		if (_model.isBiographicDataElementsAvailable && _internal_BiographicDataElements == null)
		{
			violatedConsts.push("BiographicDataElementsIsRequired");
			validationFailureMessages.push("BiographicDataElements is required");
		}
		if (_model.isBiometricDataAvailable && _internal_BiometricData == null)
		{
			violatedConsts.push("BiometricDataIsRequired");
			validationFailureMessages.push("BiometricData is required");
		}

		var styleValidity:Boolean = true;
	
	
	
	
	
	
	
    
        model_internal::_cacheInitialized_isValid = true;
        model_internal::invalidConstraints_der = violatedConsts;
        model_internal::validationFailureMessages_der = validationFailureMessages;
        return violatedConsts.length == 0 && styleValidity;
    }  

    /**
     * derived property setters
     */

    model_internal function set isValid_der(value:Boolean) : void
    {
       	var oldValue:Boolean = model_internal::_isValid;               
        if (oldValue !== value)
        {
        	model_internal::_isValid = value;
        	_model.model_internal::fireChangeEvent("isValid", oldValue, model_internal::_isValid);
        }        
    }

    /**
     * derived property getters
     */

    [Transient] 
	[Bindable(event="propertyChange")] 
    public function get _model() : _BIASIdentityEntityMetadata
    {
		return model_internal::_dminternal_model;              
    }	
    
    public function set _model(value : _BIASIdentityEntityMetadata) : void       
    {
    	var oldValue : _BIASIdentityEntityMetadata = model_internal::_dminternal_model;               
        if (oldValue !== value)
        {
        	model_internal::_dminternal_model = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_model", oldValue, model_internal::_dminternal_model));
        }     
    }      

    /**
     * methods
     */  


    /**
     *  services
     */                  
     private var _managingService:com.adobe.fiber.services.IFiberManagingService;
    
     public function set managingService(managingService:com.adobe.fiber.services.IFiberManagingService):void
     {
         _managingService = managingService;
     }                      
     
    model_internal function set invalidConstraints_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_invalidConstraints;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_invalidConstraints = value;   
			_model.model_internal::fireChangeEvent("invalidConstraints", oldValue, model_internal::_invalidConstraints);   
        }     	             
    }             
    
     model_internal function set validationFailureMessages_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_validationFailureMessages;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_validationFailureMessages = value;   
			_model.model_internal::fireChangeEvent("validationFailureMessages", oldValue, model_internal::_validationFailureMessages);   
        }     	             
    }        
     
     // Individual isAvailable functions     
	// fields, getters, and setters for primitive representations of complex id properties

}

}
