/**
 * This is a generated class and is not intended for modfication.  To customize behavior
 * of this value object you may modify the generated sub-class of this class - DeleteSubjectRequest.as.
 */

package valueObjects
{
import com.adobe.fiber.services.IFiberManagingService;
import com.adobe.fiber.valueobjects.IValueObject;
import flash.events.Event;
import flash.events.EventDispatcher;
import mx.events.PropertyChangeEvent;
import valueObjects.BIASIdentity;
import valueObjects.GenericRequestParameters;

import flash.net.registerClassAlias;
import flash.net.getClassByAlias;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;

use namespace model_internal;

[ExcludeClass]
public class _Super_DeleteSubjectRequest extends flash.events.EventDispatcher implements com.adobe.fiber.valueobjects.IValueObject
{
    model_internal static function initRemoteClassAliasSingle(cz:Class) : void 
    {
    }   
     
    model_internal static function initRemoteClassAliasAllRelated() : void 
    {
        valueObjects.GenericRequestParameters.initRemoteClassAliasSingleChild();
        valueObjects.BIASIdentity.initRemoteClassAliasSingleChild();
        valueObjects.BiographicDataType.initRemoteClassAliasSingleChild();
        valueObjects.BiographicDataItemType.initRemoteClassAliasSingleChild();
        valueObjects.BiographicDataSetType.initRemoteClassAliasSingleChild();
        valueObjects.BIASBiometricDataType.initRemoteClassAliasSingleChild();
        valueObjects.CBEFF_BIR_Type.initRemoteClassAliasSingleChild();
        valueObjects.CBEFF_BIR_TypeBIR_InformationType.initRemoteClassAliasSingleChild();
        valueObjects.BIRInfoType.initRemoteClassAliasSingleChild();
        valueObjects.BDBInfoType.initRemoteClassAliasSingleChild();
        valueObjects.MultipleTypesType.initRemoteClassAliasSingleChild();
        valueObjects.SubtypeType.initRemoteClassAliasSingleChild();
        valueObjects.SBInfoType.initRemoteClassAliasSingleChild();
        valueObjects.BaseBIRType.initRemoteClassAliasSingleChild();
        valueObjects.BiometricDataElementType.initRemoteClassAliasSingleChild();
    }

	model_internal var _dminternal_model : _DeleteSubjectRequestEntityMetadata;

	/**
	 * properties
	 */
	private var _internal__GenericRequestParameters : valueObjects.GenericRequestParameters;
	private var _internal_Identity : valueObjects.BIASIdentity;

    private static var emptyArray:Array = new Array();

    /**
     * derived property cache initialization
     */  
    model_internal var _cacheInitialized_isValid:Boolean = false;   
    
	model_internal var _changeWatcherArray:Array = new Array();   

	public function _Super_DeleteSubjectRequest() 
	{	
		_model = new _DeleteSubjectRequestEntityMetadata(this);
	
		// Bind to own data properties for cache invalidation triggering  
       
	}

    /**
     * data property getters
     */
	[Bindable(event="propertyChange")] 
    public function get _GenericRequestParameters() : valueObjects.GenericRequestParameters    
    {
            return _internal__GenericRequestParameters;
    }    
	[Bindable(event="propertyChange")] 
    public function get Identity() : valueObjects.BIASIdentity    
    {
            return _internal_Identity;
    }    

    /**
     * data property setters
     */      
    public function set _GenericRequestParameters(value:valueObjects.GenericRequestParameters) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal__GenericRequestParameters == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:valueObjects.GenericRequestParameters = _internal__GenericRequestParameters;               
        if (oldValue !== value)
        {
            _internal__GenericRequestParameters = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_GenericRequestParameters", oldValue, _internal__GenericRequestParameters));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set Identity(value:valueObjects.BIASIdentity) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_Identity == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:valueObjects.BIASIdentity = _internal_Identity;               
        if (oldValue !== value)
        {
            _internal_Identity = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "Identity", oldValue, _internal_Identity));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    

    /**
     * data property setter listeners
     */   

   model_internal function setterListenerAnyConstraint(value:flash.events.Event):void
   {
        if (model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }        
   }   

    /**
     * valid related derived properties
     */
    model_internal var _isValid : Boolean;
    model_internal var _invalidConstraints:Array = new Array();
    model_internal var _validationFailureMessages:Array = new Array();

    /**
     * derived property calculators
     */

    /**
     * isValid calculator
     */
    model_internal function calculateIsValid():Boolean
    {
        var violatedConsts:Array = new Array();    
        var validationFailureMessages:Array = new Array();    

		if (_model.is_GenericRequestParametersAvailable && _internal__GenericRequestParameters == null)
		{
			violatedConsts.push("_GenericRequestParametersIsRequired");
			validationFailureMessages.push("_GenericRequestParameters is required");
		}
		if (_model.isIdentityAvailable && _internal_Identity == null)
		{
			violatedConsts.push("IdentityIsRequired");
			validationFailureMessages.push("Identity is required");
		}

		var styleValidity:Boolean = true;
	
	
    
        model_internal::_cacheInitialized_isValid = true;
        model_internal::invalidConstraints_der = violatedConsts;
        model_internal::validationFailureMessages_der = validationFailureMessages;
        return violatedConsts.length == 0 && styleValidity;
    }  

    /**
     * derived property setters
     */

    model_internal function set isValid_der(value:Boolean) : void
    {
       	var oldValue:Boolean = model_internal::_isValid;               
        if (oldValue !== value)
        {
        	model_internal::_isValid = value;
        	_model.model_internal::fireChangeEvent("isValid", oldValue, model_internal::_isValid);
        }        
    }

    /**
     * derived property getters
     */

    [Transient] 
	[Bindable(event="propertyChange")] 
    public function get _model() : _DeleteSubjectRequestEntityMetadata
    {
		return model_internal::_dminternal_model;              
    }	
    
    public function set _model(value : _DeleteSubjectRequestEntityMetadata) : void       
    {
    	var oldValue : _DeleteSubjectRequestEntityMetadata = model_internal::_dminternal_model;               
        if (oldValue !== value)
        {
        	model_internal::_dminternal_model = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_model", oldValue, model_internal::_dminternal_model));
        }     
    }      

    /**
     * methods
     */  


    /**
     *  services
     */                  
     private var _managingService:com.adobe.fiber.services.IFiberManagingService;
    
     public function set managingService(managingService:com.adobe.fiber.services.IFiberManagingService):void
     {
         _managingService = managingService;
     }                      
     
    model_internal function set invalidConstraints_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_invalidConstraints;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_invalidConstraints = value;   
			_model.model_internal::fireChangeEvent("invalidConstraints", oldValue, model_internal::_invalidConstraints);   
        }     	             
    }             
    
     model_internal function set validationFailureMessages_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_validationFailureMessages;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_validationFailureMessages = value;   
			_model.model_internal::fireChangeEvent("validationFailureMessages", oldValue, model_internal::_validationFailureMessages);   
        }     	             
    }        
     
     // Individual isAvailable functions     
	// fields, getters, and setters for primitive representations of complex id properties

}

}
