/**
 * This is a generated class and is not intended for modfication.  To customize behavior
 * of this value object you may modify the generated sub-class of this class - Image.as.
 */

package valueObjects
{
import com.adobe.fiber.services.IFiberManagingService;
import com.adobe.fiber.valueobjects.IValueObject;
import flash.events.Event;
import flash.events.EventDispatcher;
import flash.utils.ByteArray;
import mx.events.PropertyChangeEvent;

import flash.net.registerClassAlias;
import flash.net.getClassByAlias;
import com.adobe.fiber.core.model_internal;
import com.adobe.fiber.valueobjects.IPropertyIterator;
import com.adobe.fiber.valueobjects.AvailablePropertyIterator;

use namespace model_internal;

[ExcludeClass]
public class _Super_Image extends flash.events.EventDispatcher implements com.adobe.fiber.valueobjects.IValueObject
{
    model_internal static function initRemoteClassAliasSingle(cz:Class) : void 
    {
    }   
     
    model_internal static function initRemoteClassAliasAllRelated() : void 
    {
    }

	model_internal var _dminternal_model : _ImageEntityMetadata;

	/**
	 * properties
	 */
	private var _internal_ContentType : String;
	private var _internal_FingerPosition : String;
	private var _internal_HandPosition : String;
	private var _internal_ImageData : ByteArray;

    private static var emptyArray:Array = new Array();

    /**
     * derived property cache initialization
     */  
    model_internal var _cacheInitialized_isValid:Boolean = false;   
    
	model_internal var _changeWatcherArray:Array = new Array();   

	public function _Super_Image() 
	{	
		_model = new _ImageEntityMetadata(this);
	
		// Bind to own data properties for cache invalidation triggering  
       
	}

    /**
     * data property getters
     */
	[Bindable(event="propertyChange")] 
    public function get ContentType() : String    
    {
            return _internal_ContentType;
    }    
	[Bindable(event="propertyChange")] 
    public function get FingerPosition() : String    
    {
            return _internal_FingerPosition;
    }    
	[Bindable(event="propertyChange")] 
    public function get HandPosition() : String    
    {
            return _internal_HandPosition;
    }    
	[Bindable(event="propertyChange")] 
    public function get ImageData() : ByteArray    
    {
            return _internal_ImageData;
    }    

    /**
     * data property setters
     */      
    public function set ContentType(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_ContentType == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_ContentType;               
        if (oldValue !== value)
        {
            _internal_ContentType = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "ContentType", oldValue, _internal_ContentType));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set FingerPosition(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_FingerPosition == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_FingerPosition;               
        if (oldValue !== value)
        {
            _internal_FingerPosition = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "FingerPosition", oldValue, _internal_FingerPosition));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set HandPosition(value:String) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_HandPosition == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:String = _internal_HandPosition;               
        if (oldValue !== value)
        {
            _internal_HandPosition = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "HandPosition", oldValue, _internal_HandPosition));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    
    public function set ImageData(value:ByteArray) : void 
    {    	
        var recalcValid:Boolean = false;
    	if (value == null || _internal_ImageData == null)
    	{
    		recalcValid = true;
    	}	
    	
    	
    	var oldValue:ByteArray = _internal_ImageData;               
        if (oldValue !== value)
        {
            _internal_ImageData = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "ImageData", oldValue, _internal_ImageData));
        }    	     
        
        if (recalcValid && model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }  
    }    

    /**
     * data property setter listeners
     */   

   model_internal function setterListenerAnyConstraint(value:flash.events.Event):void
   {
        if (model_internal::_cacheInitialized_isValid)
        {
            model_internal::isValid_der = model_internal::calculateIsValid();
        }        
   }   

    /**
     * valid related derived properties
     */
    model_internal var _isValid : Boolean;
    model_internal var _invalidConstraints:Array = new Array();
    model_internal var _validationFailureMessages:Array = new Array();

    /**
     * derived property calculators
     */

    /**
     * isValid calculator
     */
    model_internal function calculateIsValid():Boolean
    {
        var violatedConsts:Array = new Array();    
        var validationFailureMessages:Array = new Array();    

		if (_model.isContentTypeAvailable && _internal_ContentType == null)
		{
			violatedConsts.push("ContentTypeIsRequired");
			validationFailureMessages.push("ContentType is required");
		}
		if (_model.isFingerPositionAvailable && _internal_FingerPosition == null)
		{
			violatedConsts.push("FingerPositionIsRequired");
			validationFailureMessages.push("FingerPosition is required");
		}
		if (_model.isHandPositionAvailable && _internal_HandPosition == null)
		{
			violatedConsts.push("HandPositionIsRequired");
			validationFailureMessages.push("HandPosition is required");
		}
		if (_model.isImageDataAvailable && _internal_ImageData == null)
		{
			violatedConsts.push("ImageDataIsRequired");
			validationFailureMessages.push("ImageData is required");
		}

		var styleValidity:Boolean = true;
	
	
	
	
    
        model_internal::_cacheInitialized_isValid = true;
        model_internal::invalidConstraints_der = violatedConsts;
        model_internal::validationFailureMessages_der = validationFailureMessages;
        return violatedConsts.length == 0 && styleValidity;
    }  

    /**
     * derived property setters
     */

    model_internal function set isValid_der(value:Boolean) : void
    {
       	var oldValue:Boolean = model_internal::_isValid;               
        if (oldValue !== value)
        {
        	model_internal::_isValid = value;
        	_model.model_internal::fireChangeEvent("isValid", oldValue, model_internal::_isValid);
        }        
    }

    /**
     * derived property getters
     */

    [Transient] 
	[Bindable(event="propertyChange")] 
    public function get _model() : _ImageEntityMetadata
    {
		return model_internal::_dminternal_model;              
    }	
    
    public function set _model(value : _ImageEntityMetadata) : void       
    {
    	var oldValue : _ImageEntityMetadata = model_internal::_dminternal_model;               
        if (oldValue !== value)
        {
        	model_internal::_dminternal_model = value;
        	this.dispatchEvent(mx.events.PropertyChangeEvent.createUpdateEvent(this, "_model", oldValue, model_internal::_dminternal_model));
        }     
    }      

    /**
     * methods
     */  


    /**
     *  services
     */                  
     private var _managingService:com.adobe.fiber.services.IFiberManagingService;
    
     public function set managingService(managingService:com.adobe.fiber.services.IFiberManagingService):void
     {
         _managingService = managingService;
     }                      
     
    model_internal function set invalidConstraints_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_invalidConstraints;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_invalidConstraints = value;   
			_model.model_internal::fireChangeEvent("invalidConstraints", oldValue, model_internal::_invalidConstraints);   
        }     	             
    }             
    
     model_internal function set validationFailureMessages_der(value:Array) : void
    {  
     	var oldValue:Array = model_internal::_validationFailureMessages;
     	// avoid firing the event when old and new value are different empty arrays
        if (oldValue !== value && (oldValue.length > 0 || value.length > 0))
        {
            model_internal::_validationFailureMessages = value;   
			_model.model_internal::fireChangeEvent("validationFailureMessages", oldValue, model_internal::_validationFailureMessages);   
        }     	             
    }        
     
     // Individual isAvailable functions     
	// fields, getters, and setters for primitive representations of complex id properties

}

}
